=== debian/watch ===
version=4
opts=uversionmangle=s/.-ReleasePack.*//g https://github.com/QEF/q-e/tags .*/releases/download/qe-[\d.]+/qe-([\d.]+)(-ReleasePack)?\.(tar\.(?:bz2|gz)|tgz)
